#!/usr/bin/perl -w
# Example program which will
# 1) login to a mailbox and retrieve and delete all messages
# or
# 2)  make stress testing with or without attempt to login (no logout)
#
# pop3client.pl <host> <port> <user> <password> [<connections>|del]
# pop3client.pl <host> <port> stress[login][<connections>]
#
# Cannot be used with stunnel port 995

my $pop3host = $ARGV[0] || '';
my $port = $ARGV[1] || 110;
my $username = $ARGV[2] || '';
my $password = $ARGV[3] || '';
my $keep = $ARGV[4] || 'keep';
my $count = 0;
if( $pop3host eq '') {
print "
$0 <host> <port> <user> <password> [del]
Reading all emails from a pop3 server
Defaults: do not delete emails (use 'del' for deleting)

$0 <host> <port> <user> <password> <connections>
   make <connections> concurrent connections 
$0 <host> <port> - - <connections>
   just opening connection and sending QUIT 
$0 <host> <port> stress - <connections>
   attempt to login with generated usernames ('stress999') 
$0 <host> <port> <user> <password> <connections>
   attempting to login with real user
   just quitting after login
";
exit;
}

if ($keep =~ /[0-9]+$/) { # stresstest
$count = $keep;
$keep = '*stress';
}

if ($keep eq '*stress') {
	stresstest($username, $password, $count);
} else {
	readmail($keep);
}
exit;

sub readmail {
#------------------
use Net::POP3;
# read and optionally delete all email from an account
my ($keep) = @_;
# read the mail
print "Reading all email from $pop3host user $username delete=$keep\n";
# Constructors
my $pop = Net::POP3->new($pop3host, Timeout => 30, Debug => 0,  Port => $port);
my $res = $pop->login($username, $password); 
if ($res && $res > 0) {
	my $msgnums = $pop->list; # hashref of msgnum => size
	foreach my $msgnum (keys %$msgnums) {
		my $msg = $pop->get($msgnum);
		print @$msg;
		$pop->delete($msgnum) if $keep eq 'del';
	}	
}
$pop->quit;
}

sub stresstest {
#------------------
# establish count simultaneous connections to the server, just opening and sending QUIT
# (username, password) = ('-','-')
# or attempting to login with generated username (username = 'stress') and/or generated password ( password = '-')

my ($username, $password, $count) = @_;

use Net::Telnet ();
		
my $i;
print "Creating $count connections to $pop3host using $username,$password\n";

for ($i=1;$i <= $count;$i++) {
if (fork() == 0) {
	print "** Connection $i starting\n";
	if ($username ne '-') { 
		my $pop = Net::POP3->new($pop3host, Timeout => 20, Debug => 0,  Port => $port);
		my $res = $pop->login($username.($username eq 'stress' ? "$$":''), ($password eq '-' ? 'xxx':$password));
		print "Conn $i: $username not logged in !\n" if !defined($res);
		$pop->quit;
	} else {
         my $t = new Net::Telnet(Binmode => 1, Host => $pop3host, Port => $port,  Timeout => 20, Errmode => 'return');
		$t->put("QUIT\r\n") if $t;
	my	$lines = $t->getline(Timeout => 5) if $t;
		$t->close() if $t;
	}
	print "** Connection $i ended\n";
      exit;
}
}
print "** Wait for $count connections\n";
}
